/* VOTE - FOR - IT 3

Aufbau der addons/adminmod/config/votecommands.cfg:

vote_command:exec_command:param:group:vote text

vote_command	= 	ein registrierter admin_Befehl, der in der Console zur Verfgung stehen soll, um den Vote aufzurufen
exec_command	= 	admin_Befehl von anderen Plugins
param			=	* wenn ein Wert mit dem vote_command angegeben werden muss, sonst entsprechenden Wert festlegen.
group			=	m fr map, p fr Spieler, w fr waffe, n fr Zahl
vote text		= 	ein Vote-Text, der angezeigt wird. %s dient als Platzhalter fr den Inhalt, den man mit dem vote_command angibt.

*/

#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "v3_21.08.04";

new g_VoteFile[MAX_TEXT_LENGTH]="addons/adminmod/config/votecommands.cfg";

#define MAX_COMMANDS	30

new g_VoteCmd[MAX_COMMANDS][MAX_COMMAND_LENGTH];
new g_ExecCmd[MAX_COMMANDS][MAX_COMMAND_LENGTH];
new g_Param[MAX_COMMANDS][MAX_COMMAND_LENGTH];
new g_Group[MAX_COMMANDS][1];
new g_VoteText[MAX_COMMANDS][MAX_TEXT_LENGTH];
new g_loaded;

new g_VoteContent[MAX_TEXT_LENGTH];
new g_vote_id;
new g_vote_canceled;

/*Waffennamen*/
#define MAX_ITEMS 35
new g_CS_Commands[MAX_ITEMS][]= {
	"all",
	"menu",
	"team",
    "glock",
    "usp",
    "p228",
    "deagle",
    "elites",
    "fn57",
    "m3",
    "xm1014",
    "mac10",
    "mp5",
    "ump45",
    "p90",
    "tmp",
    "galil",
    "ak47",
    "scout",
    "sg552",
    "awp",
    "g3sg1",
    "famas",
    "aug",
    "m4a1",
    "sg550",
    "m249",
    "vest",
    "vesthelm",
    "flash",
    "hegren",
    "sgren",
    "defuser",
    "nvgs",
    "shield"
};


public plugin_init() {
	if(getvar("file_access_read")){
		new Data[MAX_DATA_LENGTH];
		new iLine;
		new i;
		if(fileexists(g_VoteFile)){
			iLine=filesize(g_VoteFile);
			for(i=1;i<=iLine;i++){
				readfile(g_VoteFile,Data,i,MAX_DATA_LENGTH);
				strsep(Data,":",g_VoteCmd[g_loaded],MAX_COMMAND_LENGTH,g_ExecCmd[g_loaded],MAX_COMMAND_LENGTH,
					g_Param[g_loaded],MAX_COMMAND_LENGTH,g_Group[g_loaded],3,g_VoteText[g_loaded],MAX_TEXT_LENGTH);
				snprintf(Data,MAX_DATA_LENGTH,"%s <param>: %s --> %s",g_VoteCmd[g_loaded],g_VoteText[g_loaded],g_ExecCmd[g_loaded]);
				plugin_registercmd(g_VoteCmd[g_loaded],"admin_vote",ACCESS_MAP,Data);
				g_loaded++;
				strinit(Data);
			}
			g_loaded--;
			snprintf(Data,MAX_DATA_LENGTH,"[VFI3] Loaded %i vote commands!",g_loaded);
			selfmessage(Data);
			plugin_registerinfo("Vote-For-It 3","Includes all vote commands set up in votecommands.cfg!",AM_VERSION_STRING);
			plugin_registercmd("admin_vote_cancel","admin_vote_cancel",ACCESS_VOTE_MAP,"admin_vote_cancel: cancels the voting");
		}else{
			plugin_registerinfo("Vote-For-It 3","PLUGIN DISABLED! TAKE A LOOK IN LOG FILES!",AM_VERSION_STRING);
			selfmessage("[VFI3] ERROR: file not found: addons/adminmod/config/votecommands.cfg!");
		}
	}else{
		plugin_registerinfo("Vote-For-It 3","PLUGIN DISABLED! TAKE A LOOK IN LOG FILES!",AM_VERSION_STRING);
		selfmessage("[VFI3] ERROR: file_access_read is not set to 1 in adminmod.cfg!");
	}
	return PLUGIN_CONTINUE;
}

public admin_vote_cancel(HLCommand,HLData,HLUserName,UserIndex) {
	if(!vote_allowed()){
		selfmessage("[VFI3] Vote wurde abgebrochen!");
		g_vote_canceled=1;
	}else{
		selfmessage("[VFI3] Ein Vote ist zur Zeit nicht im Gange!");
	}
	return PLUGIN_HANDLED;
}


public admin_vote(HLCommand,HLData,HLUserName,UserIndex) {
	if(vote_allowed()){
		new Data[MAX_DATA_LENGTH];
		new Command[MAX_COMMAND_LENGTH];
		new User[MAX_NAME_LENGTH];
		new Text[MAX_TEXT_LENGTH];
		new i;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		
		for(i=0;i<=g_loaded;i++){
			if(strcmp(g_VoteCmd[i],Command)==0){
				if(g_Param[i][0]!='*'){
					strcpy(Data,g_Param[i],MAX_COMMAND_LENGTH);
				}
				if(g_Group[i][0]=='m'){
					if(!valid_map(Data)){
						snprintf(Text,MAX_TEXT_LENGTH,"[VFI3] Kann %s nicht finden oder sie ist nicht erlaubt!",Data);
						selfmessage(Text);
						return PLUGIN_HANDLED;
					}
				}else if(g_Group[i][0]=='p'){
					if(!checkplayer(Data)){
						snprintf(Text,MAX_TEXT_LENGTH,"[VFI3] Du kannst keinen Vote gegen %s machen!",Data);
						selfmessage(Text);
						return PLUGIN_HANDLED;
					}
				}else if(g_Group[i][0]=='w'){
					if(!checkweapons(Data)){
						snprintf(Text,MAX_TEXT_LENGTH,"[VFI3] %s ist im plugin_CS unbekannt!",Data);
						selfmessage(Text);
						return PLUGIN_HANDLED;
					}
				}else if(g_Group[i][0]=='n'){
					if(strtonum(Data)==0){
						numtostr(strtonum(Data),Data);
					}
				}
				g_vote_id = i;
				strcpy(g_VoteContent,Data,MAX_DATA_LENGTH);
				snprintf(Text,MAX_TEXT_LENGTH,g_VoteText[i],Data);
				vote(Text,"JA","NEIN","NormVote",Text);
				return PLUGIN_HANDLED;
				break;
			}
		}
		selfmessage("[VFI3] Kann den Vote Befehl nicht finden!");
	}else{
		selfmessage("[VFI3] Ein Vote ist zur Zeit nicht erlaubt!");
	}
	return PLUGIN_HANDLED;
}


checkplayer(Data[]){
	new Player[MAX_NAME_LENGTH];
	new Dummy[MAX_DATA_LENGTH];
	strsep(Data," ",Player,MAX_NAME_LENGTH,Dummy,MAX_DATA_LENGTH);
	if(check_user(Player)==1){
		get_username(Player,Player,MAX_NAME_LENGTH);
		if(!check_immunity(Player)) {
			if(strlen(Dummy)!=0){
				snprintf(Data,MAX_DATA_LENGTH,"%s %s",Player,Dummy);
			}else{
				snprintf(Data,MAX_DATA_LENGTH,"%s",Player);
			}
			return 1;
		}
	}
	return 0;
}

checkweapons(Data[]){
	new Command[MAX_NAME_LENGTH];
	new Dummy[MAX_TEXT_LENGTH];
	strsep(Data," ",Command,MAX_NAME_LENGTH,Dummy,MAX_TEXT_LENGTH);
	new i;
	for(i=0;i<=MAX_ITEMS;i++){
		if(strcmp(Command,g_CS_Commands[i])==0){
			return 1;
			break;
		}
	}
	if(checkplayer(Command)){
		return 1;
	}
	return 0;
}

public NormVote(WinningOption,HLData,VoteCount,UserCount) {
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iRatioCalc;
	new iRatio;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	iRatio=getvar("admin_vote_ratio");
	iRatioCalc=iRatio*UserCount/100;
	if(WinningOption==1 && !g_vote_canceled){
		if (VoteCount >= iRatioCalc ) {
			snprintf(Text, MAX_TEXT_LENGTH, "^"%s^"^n wurde mit %i JA Stimmen^n zugestimmt!",Data,VoteCount);
			centersay(Text,12,100,140,255);
			say(Text);
			plugin_exec(g_ExecCmd[g_vote_id],g_VoteContent);
			g_vote_id=0;
			strinit(g_VoteContent);
			return PLUGIN_HANDLED;
		}
	}
	snprintf(Text, MAX_TEXT_LENGTH, "^"%s^"^n Vote abgeschlossen, aber nicht^n genug JA-Stimmen erhalten (notwendig %i)",Data,iRatioCalc);
	centersay(Text,12,100,140,255);
	say(Text);
	g_vote_canceled=0;
	g_vote_id=0;
	strinit(g_VoteContent);
	return PLUGIN_HANDLED;
}

